-- TODO: Make LOCAL!
BGCF = {}

-- Player Data, indexed on GUID
local BGCFPD =  {}

-- Node Data, indexed on "real" nodeID
local ND = {}

Nodes = {}

if not BGCFramePublic then BGCFramePublic = {} end

function BGCFramePublic.Reset()
	PD = {}
	ND = {}
end

function BGCFramePublic.PlayerAt(guid,nodeID,isHealer)
	if not guid or not nodeID then
		return
	end
	if not BGCFPD[guid] then BGCFPD[guid] = {} end
	local p = BGCFPD[guid]
	
	if p.lastNode then
		if p.lastNode == nodeID then
			return
		end
		BGCF.RemovePlayerFromNode(p.lastNode,p.isHealer)
	end
	BGCF.AddPlayerToNode(nodeID,isHealer)
	p.lastNode = p.node
	p.node = nodeID
	if isHealer and not p.isHealer then p.isHealer = isHealer end
end

function BGCFramePublic.PlayerDied(guid)
	if not guid then return end
	if not BGCFPD[guid] then BGCFPD[guid] = {} end
	local p = BGCFPD[guid]
	
	if p and p.node then
		BGCF.RemovePlayerFromNode(p.node,p.isHealer)
		p.lastNode = nil
		p.node = nil
	end
	
end

function BGCF.RemovePlayerFromNode(nodeID,isHealer)
	local n = ND[nodeID]
	if not n then return end
	if isHealer then
		n.heal = ( n.heal or 0 ) - 1
	else
		n.damage = ( n.damage or 0 ) - 1
	end	
	BGCF.UpdatePlayers(nodeID)
end

function BGCF.AddPlayerToNode(nodeID,isHealer)
	local n = ND[nodeID]
	if not n then return end
	if isHealer then
		n.heal = ( n.heal or 0 ) + 1
	else
		n.damage = ( n.damage or 0 ) + 1
	end
	BGCF.UpdatePlayers(nodeID)
end

function BGCF.UpdatePlayers(nodeID)
	-- TOOD: HOW DO I DO THIS
	local n = ND[nodeID]
	BGCF.SetHealers(nodeID,n.heal)
	BGCF.SetDamage(nodeID,n.damage)
	BGCF.SetRatio(nodeID,0)
end

function BGCF_OnLoad(self)
	self:SetScript("OnEvent",BGCF.OnEvent);
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterForDrag("LeftButton");
	self:Hide()
	self:SetParent(nil)
end

function BGCF.SetIcon(nodeID,index)
	if index and index > 0 then
	 	local x1, x2, y1, y2 = GetPOITextureCoords(index);
		_G["BG_Control"..BGCF.IndexFromNodeID(nodeID).."_Icon"]:SetTexCoord(x1, x2, y1, y2);
	end
end

function BGCF.SetRatio(nodeID,ratio)
	_G["BG_Control"..BGCF.IndexFromNodeID(nodeID).."_Ratio"]:SetText(tostring(ratio))
end

function BGCF.SetHealers(nodeID,count)
	_G["BG_Control"..BGCF.IndexFromNodeID(nodeID).."_H"]:SetText(tostring(count))
end

function BGCF.SetDamage(nodeID,count)
	_G["BG_Control"..BGCF.IndexFromNodeID(nodeID).."_D"]:SetText(tostring(count))
end

function BGCF.SetName(nodeID,name)
	_G["BG_Control"..BGCF.IndexFromNodeID(nodeID).."_Name"]:SetText(tostring(name))
	_G["BG_Control"..BGCF.IndexFromNodeID(nodeID)]:Show()
end

function BGCF.OnClick(self)

end



function BGCF_OnDragStart(self)
	print("Drag start")
	if BGCF.IsMovable() then
		print("Movable")
		self:StartMoving();	
	end
end

function BGCFLock_OnClick(self)
	BG_Control_SV.Options.MoveFrame = nil;
	BGCFramePublic.EvaluateLockButton();
end

function BGCF_OnDragStop(self)
	print("DragStop")
	self:StopMovingOrSizing();
end

function BGCF.IsMovable()
	return not InCombatLockdown() and BG_Control_SV.Options
.MoveFrame
end

function BGCFramePublic.EvaluateLockButton()
	if not BG_Control_SV.Options.MoveFrame and BG_ControlLock:IsShown() then
		BG_ControlLock:Hide()
	elseif BG_Control_SV.Options.MoveFrame and not BG_ControlLock:IsShown() then
		BG_ControlLock:Show()
	end
end

function BGCF.Addon_Loaded(self,...)
	local name = ...
	if "BG_Control" == name then
		print("Loaded BG_Control frames")
		self:UnregisterEvent("ADDON_LOADED");
		
		BGCFramePublic.EvaluateLockButton();
		self:RegisterForDrag("LeftButton");
		self:RegisterEvent("WORLD_MAP_UPDATE");

		-- Cleanup
		BGCF.Addon_Loaded = nil
	end
end

function BGCF.World_Map_Update(...)
	if not BGCF.Landmarks or BGCF.Landmarks ~= GetNumMapLandmarks() then
		BGCF.UpdateNodeNames()
	end
	
	BGCF.UpdateNodeIcons()
end

function BGCF.UpdateNodeNames()
	local items = GetNumMapLandmarks()
	
	if items > 0 then
		BGCF.HideAllRows()
		
		local count = 0
		for i=1,items do
			
			local name, description, textureIndex, x, y, mapLinkID, showInBattleMap, graveyardID, areaID, poiID = GetMapLandmarkInfo(i)
			print("UPDATING NAMES! "..tostring(name))
			-- If it's on the battle map, we care about it here too
			print("BATTLEMAP: "..tostring(showInBattleMap).." ID: "..tostring(poiID))
			if poiID and showInBattleMap then
				count = count + 1
				Nodes[poiID]=count
				BGCF.SetName(poiID,name)				
				if not ND[poiID] then ND[poiID] = {} end
				ND[poiID].name = name
				ND[poiID].description = description
			end
	
		end
		BGCF.Landmarks = count
	end
end

function BGCF.UpdateNodeIcons()
	local items = GetNumMapLandmarks()
		
	if items > 0 then
		for i=1,items do
			local name, description, textureIndex, x, y, mapLinkID, showInBattleMap, graveyardID, areaID, poiID = GetMapLandmarkInfo(i)
			if textureIndex and textureIndex > 0 and Nodes[poiID] then
				
				BGCF.SetIcon(poiID,textureIndex)
			end

		end
	end
end

function BGCF.IndexFromNodeID(nodeID)
	return Nodes[nodeID]
end

function BGCFramePublic.BattlegroundEnded()
	BGCF.Landmarks = nil
	BG_Control:Hide()
end

function BGCFramePublic.BattlegroundStarted()
	BGCF.Landmarks = nil
	BGCF.HideAllRows()
	BG_Control:Show()
end

function BGCF.HideAllRows()
	for i = 1,25 do
		local f = _G["BG_Control"..i]
		if f:IsShown() then
			f:Hide()
		end
	end
end

function BGCF.OnEvent(self, event, ...)
	if "WORLD_MAP_UPDATE" == event then
		BGCF.World_Map_Update(...)
	elseif "ADDON_LOADED" == event then
		BGCF.Addon_Loaded(self,...)
	end
	
end